import { Smallthing} from '__smallthing';

Smallthing.classUserParameters = {

    ver: Smallthing.SAVAVERSION,
    
    points: 0,

    coins: 0,

    stars: 0,

    itemUnlocked: {

        'speed': 0,
        'wave': 0,
        'ratio': 0, 
        '1': 1, // ch1
        '2': 0, // ch2
        '3': 0, // ch3
        '4': 0, // ch4
        '5': 0, // ch5
    },

    itemSold: {

    },

    missions: [],

    levels: {
        
        // "1.1":2 // DEBUG <--- identifica che ci sono 2 stelle            
    },

    isTutorialCreateLevels: false,

    isTutorialDone: false, 

    collectiblesDone: {
    },

    worldsUnlock: {
        "worlds/Main_Menu_Wold1":true,
        "worlds/Main_Menu_Wold2":false,
        "worlds/Main_Menu_Wold3":false,
        "worlds/Main_Menu_Wold4":false,
        "worlds/Main_Menu_Wold5":false,
        "worlds/Main_Menu_Wold6":false,
        "worlds/Main_Menu_Wold7":false,
        "worlds/Main_Menu_Wold8":false,
        "worlds/Main_Menu_Wold9":false,
        "worlds/Main_Menu_Wold10":false,
        "worlds/Main_Menu_Wold11":false,
        "worlds/Main_Menu_Wold12":false,
        "worlds/Main_Menu_Wold13":false,
        "worlds/Main_Menu_Wold14":false,
        "worlds/Main_Menu_Wold15":false,
        "worlds/Main_Menu_Wold16":false,
        "worlds/Main_Menu_Wold17":false,
        "worlds/Main_Menu_Wold18":false,
        "worlds/Main_Menu_Wold19":false,
        "worlds/Main_Menu_Wold20":false,
        "worlds/Main_Menu_Wold21":false,
        "worlds/Main_Menu_Wold22":false,
        "worlds/Main_Menu_Wold23":false,
        "worlds/Main_Menu_Wold24":false,
        "worlds/Main_Menu_Wold25":false,
        "worlds/Main_Menu_Wold26":false,
        "worlds/Main_Menu_Wold27":false,
        "worlds/Main_Menu_Wold28":false,
        "worlds/Main_Menu_Wold29":false,
        "worlds/Main_Menu_Wold30":false,
        "worlds/Main_Menu_Wold31":false,
        "worlds/Main_Menu_Wold32":false,
        "worlds/Main_Menu_Wold33":false,
        "worlds/Main_Menu_Wold34":false,
        "worlds/Main_Menu_Wold35":false,
        "worlds/Main_Menu_Wold36":false,
        "worlds/Main_Menu_Wold37":false,
        "worlds/Main_Menu_Wold38":false,
        "worlds/Main_Menu_Wold39":false,
        "worlds/Main_Menu_Wold40":false,
        "worlds/Main_Menu_Wold41":false,
        "worlds/Main_Menu_Wold42":false,
        "worlds/Main_Menu_Wold43":false,
        "worlds/Main_Menu_Wold44":false,
        "worlds/Main_Menu_Wold45":false,
        "worlds/Main_Menu_Wold46":false,
        "worlds/Main_Menu_Wold47":false,
        "worlds/Main_Menu_Wold48":false,
        "worlds/Main_Menu_Wold49":false,
        "worlds/Main_Menu_Wold50":false,
    },
};

if(Smallthing.GAMEDATA.validate !== true) 
{
    Smallthing.GAMEDATA = {

        validate: true,

        // audio parameters
        optionsParameters: {
 
            isSfx: true,
            isMusic: true
        },

        tutorialIntro: {
            isDone: false
        },

        missionsParameters: {
            isTutorial: false, 
            timerStart: 0, // tempo di partenza, se 0 vuol dire che ancora non è stato abilitato
            timerOffset: 8 * 60 * 60 * 1000, // 8h in millisecondi
        },

        // costi elmenti
        shopWaveCost1: 100,
        shopWaveCost2: 300,
        shopWaveCost3: 700,
        shopSpeedCost1: 100,
        shopSpeedCost2: 300,
        shopSpeedCost3: 700,
        shopRatioCost1: 100,
        shopRatioCost2: 300,
        shopRatioCost3: 700,
        shopAnaisCost: 3000,
        shopNicoleCost: 3000,
        shopRichardCost: 3000,

        checkApplicationVersion: true,
        applicationVersion: '1.0.0',
        thereIsNewApplicationVersion: false,

        // grandezza della cella
        cellSize: 70,

        GODMODE: false,

        // grndezza massima della griglia DEVE ESSERE DISPARI PERCHE' SI PARTE DA CENTRO SCHERMO
        gridWidthMax: 14,
        gridHeightMax: 12,

        currentWorldPath: '',

        levelsData: null,

        // livello da caricare WORLD.LEVEL
        currentLevelGame: null, // {world: '1.', tag:'1.1', stars:0}; di default è null se è differente da null allora vuol dire che avevamo giocato a qualche livello quindi apriamo il livello che ci interessa

        isTOOLMODE: false,

        isTutorialInAction: false,

        isPause: false,

        fileApplicationVersion: '##applicationversion',
        fileLocalLevels: '##local_levels',
        filePlayerJSON: '##player.json',
        fileEnemyJSON: '##enemy.json',
        fileGameParameters: '##save.json',
        fileGameCollect: '##collect.json',
        fileRewardParameters: '##reward.json',
        fileOptionsParameters: '##options.json',
        fileMapScroll: '##map.scroll',
        fileMapCurrentWorld: '##map.currentworld',
        fileVersion: '##version',
        fileScrollSelectLevels: '##scrollcurrentselectlevels',
        filePrivacy: '##privacy',
        fileMissions: '##missions',
        fileMissionsBuffer: '##missionsBuffer',
        fileTutorialIntroParameters: '##tutorialintro',

        monsterDistanceToKill: 60,
        bulletDistanceToKill: 40,

        players: [],//, cc.Characters.Darwin, cc.Characters.Anais, cc.Characters.Richard]; // si inserisce qui i players da caricare, il numero di elementi identifica il numero di giocatori
        enemies: [],

        isKeyPlaced: false,
        isDoorPlaced: false,

        keyObject: null,
        doorObject: null,

        relativeCoin: 0,

        defaultPlayerSpeed: 100,
        defaultBombTimer: 4.0,
        defaultBombPropagationSpeed: .2,
        defaultTimeToReleaseBomb: 1.0,
        defaultUIGameScaleButtonBomb: 1.75,
        waiting_time_in_front_bomb: {
        "witless":1.0,
        "normal":0.8,
        "wicked":0.5
        },

        SpecialMissions: [
            's.1',
            's.2',
            's.3',
            's.4',
            's.5',
            's.6',
            's.7',
            's.8',
            's.9',
            's.10',
            's.11',
            's.12',
            's.13',
            's.14',
            's.15',
            's.16',
            's.17',
            's.18',
            's.19',
            's.20',            
        ],

        SpecialMissionsBuffer: [
            's.1',
            's.2',
            's.3',
            's.4',
            's.5',
            's.6',
            's.7',
            's.8',
            's.9',
            's.10',
            's.11',
            's.12',
            's.13',
            's.14',
            's.15',
            's.16',
            's.17',
            's.18',
            's.19',
            's.20'
        ],

        QuickMissions: [
            'q.1',
            'q.2',
            'q.3',
            'q.4',
            'q.5',
            'q.6',
            'q.7',
            'q.8',
            'q.9',
            'q.10',
            'q.11',
            'q.12',
            'q.13',
            'q.14',
            'q.15',
            'q.16',
            'q.17',
            'q.18',
            'q.19',
            'q.20',
            'q.21',
            'q.22',
            'q.23',
            'q.24'
        ],

        // set to true when we will want load only multiplayer levels
        isMultiplayer: false,

        progress: 0,
        progressText: 'Attendi che credo H20',

        // def timer
        TimerDef: [
            -1,
            60,
            99,
            120,
            180
        ],

        /*
        cc.EnemyAI: cc.Enum({

            None: -1,
            Witless: 1,
            Normal: 2,
            Wicked: 3
        });
        */
        EnemiesSpecific: {

            "ver": "0"
        },

        PlayerSpecific: {

            "ver": "0"
        },

        // define block/enemy/bonus definition to not use string for comparison inside the code
        Block_Border1: '1',
        Block_Border2: '2',
        Block_Border3: '3',
        Block_Wall1: '4',
        Block_Wall2: '5',
        Block_Wall3: '6',
        Block_WallBreak1: '7',
        Block_WallBreak2: '8',
        Block_Column1: '9',
        Block_Column2: 'A',
        Block_DoorHor: 'B',
        Block_DoorVer: 'C',

        Block_Color_Blue: 'D',
        Block_Color_Green: 'E',
        Block_Color_Red: 'F',
        Block_Color_Violet: 'G',
        Block_Color_Yellow: 'H',
        Block_StartP1: 'I',
        Block_StartP2: 'J',
        //Block_StartP3: 'K';
        //Block_StartP4: 'L';
        Block_Switch: 'M',
        Block_Teleport: 'N',

        // quando aggiungiamo un nemico nuovo, dobbimao aggiungere gli ID dentro 
        // gamedata.js (559)
        // tools.js (338)
        // tools.js (266)
        Enemy_Standard_Frog: 's1',
        Enemy_Standard_Crab: 's2',
        Enemy_Standard_CrabBucket: 's3',
        Enemy_Standard_Squid: 's4',
        Enemy_Standard_SquidBucket: 's5',
        Enemy_Standard_Urchin: 's6',
        Enemy_Standard_Paper: 's7',
        Enemy_Standard_PaperPlane: 's8',
        Enemy_Standard_Roll: 's9',
        Enemy_Standard_Crow1: 't1',
        Enemy_Standard_Crow2: 't2',
        Enemy_Standard1_Gray: 'sa',
        Enemy_Standard1_Blue: 'sb',
        Enemy_Standard1_Green: 'sc',
        Enemy_Standard1_Red: 'sd',
        Enemy_Standard1_Violet: 'se',
        Enemy_Standard1_Yellow: 'sf',
        Enemy_Standard2_Gray: 'sg',
        Enemy_Standard2_Blue: 'sh',
        Enemy_Standard2_Green: 'si',
        Enemy_Standard2_Red: 'sj',
        Enemy_Standard2_Violet: 'sk',
        Enemy_Standard2_Yellow: 'sl',
        Enemy_Standard3_Gray: 'sm',
        Enemy_Standard3_Blue: 'sn',
        Enemy_Standard3_Green: 'so',
        Enemy_Standard3_Red: 'sp',
        Enemy_Standard3_Violet: 'sq',
        Enemy_Standard3_Yellow: 'sr',

        Bonus_Key: 'O',
        Bonus_Door: 'P',
        Bonus_Coin: 'Q',
        Bonus_KeyRed: 'kr',
        Bonus_KeyBlue: 'kb',
        Bonus_KeyYellow: 'ky',

        Bonus_Collectionable: 'd1',

        Bonus_Star: 'R',

        Block_SwitchBlue: 'S',
        Block_SwitchRed: 'T',
        Block_SwitchYellow: 'U',

        Block_DoorHorBlue: 'V',
        Block_DoorVerBlue: 'W',
        Block_DoorHorRed: 'X',
        Block_DoorVerRed: 'Y',
        Block_DoorHorYellow: 'Z',
        Block_DoorVerYellow: 'a',

        // dati del livello corrente
        currentDataGrid: null,
        currentDataBonusGrid: null,

        // matrice dove il personaggio puo' camminare 0: libero 1: occupato
        walkableMatrix: null,

        gameParameters: null,
    };


    Smallthing.GAMEDATA.Array2D = function (x, y)
    {
        var array2D = new Array(x);

        for(var i = 0; i < array2D.length; i++)
        {
            array2D[i] = new Array(y);
        }

        return array2D;
    };

}

cc.Class({
    extends: cc.Component,

    properties: {

        prefabBonusName: {
            default: [],
            type: [cc.String]
        },
        clearAtStart: {
            default: false
        }
    },

    onLoad() {

        // don't destroy node
        // this._persistNode = true;
        // persitend
        this.node.parent = null;
        cc.game.addPersistRootNode(this.node);

        this.timeEvents = new cc.TimeEvent();
    },

    onDestroy() {

// non ha senso calcellare qui il tempo, gamedata non si cancella mai
//        if(this.timeEvents != null){this.timeEvents.destroy(); this.timeEvents = null; }
    },

    start () {

    },

    update(dt) {

        if(this.timeEvents !== undefined && this.timeEvents !== null)
            this.timeEvents.onUpdate(dt);
    },
});
