// Learn cc.Class:
//  - https://docs.cocos.com/creator/manual/en/scripting/class.html
// Learn Attribute:
//  - https://docs.cocos.com/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - https://docs.cocos.com/creator/manual/en/scripting/life-cycle-callbacks.html

cc.Class({
    extends: cc.Component,

    properties: {
        // foo: {
        //     // ATTRIBUTES:
        //     default: null,        // The default value will be used only when the component attaching
        //                           // to a node for the first time
        //     type: cc.SpriteFrame, // optional, default is typeof default
        //     serializable: true,   // optional, default is true
        // },
        // bar: {
        //     get () {
        //         return this._bar;
        //     },
        //     set (value) {
        //         this._bar = value;
        //     }
        // },
        timeToDestroy: {
            default: 3.0
        }, 
        isEnabled: {
            default: false
        }
    },

    // LIFE-CYCLE CALLBACKS:

    start () {

        var file = 'prefabs/levelsplash/prefabsLevelIntroKillAllMonsters2';
        var self = this;

        cc.resources.load(file, cc.Prefab, function(err, prefab){

            if(err !== null && err !== undefined) {
                self.state = self.State.ActiveEnemies;
                console.warn(err);
                return;
            }

            self.tv = cc.instantiate(prefab);
            self.tv.prefab = prefab;
            self.node.addChild(self.tv);

            self.tv.getComponent('levelIntroSplash').play({func:function(){
                cc.assetManager.releaseAsset(self.tv.prefab);
            }, scope:this}); 

            self.isEnabled = true;
        });
    },

    update (dt) {

        // if(this.isEnabled) {
        //     this.timeToDestroy -= dt;
        //     if(this.timeToDestroy < 0) {
        //         this.isEnabled = false;
        //         this.tv.destroy();
        //         cc.assetManager.releaseAsset(this.tv.prefab);
        //         this.tv = null;
        //     }
        // }
    },
});
