// Learn cc.Class:
//  - https://docs.cocos.com/creator/manual/en/scripting/class.html
// Learn Attribute:
//  - https://docs.cocos.com/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - https://docs.cocos.com/creator/manual/en/scripting/life-cycle-callbacks.html

import { Smallthing } from "./__smallthing";

cc.Class({
    extends: cc.Component,

    properties: {
        // foo: {
        //     // ATTRIBUTES:
        //     default: null,        // The default value will be used only when the component attaching
        //                           // to a node for the first time
        //     type: cc.SpriteFrame, // optional, default is typeof default
        //     serializable: true,   // optional, default is true
        // },
        // bar: {
        //     get () {
        //         return this._bar;
        //     },
        //     set (value) {
        //         this._bar = value;
        //     }
        // },

        onFinished: {
            default: [],
            type: [cc.Component.EventHandler]
        },

        toScale: {
            default: 1.0
        }

    },

    // LIFE-CYCLE CALLBACKS:

    onEnable () {

        this.node.scaleX = 0;
        this.node.scaleY = 0;

        cc.tween(this.node).delay(.1).to(0.5, {scaleX:this.toScale, scaleY:this.toScale}, {easing:'bounceOut'}).call(function(){
            if(this.onFinished.length > 0) {
                for(var i = 0; i < this.onFinished.length; i++) {
                    this.onFinished[i].emit([]);
                }
            }
        }, this).start();
    },

    start () {

    },

    // update (dt) {},
});
